diff options
author | Assaf Gordon <assafgordon@gmail.com> | 2016-04-17 02:28:13 -0400 |
---|---|---|
committer | Assaf Gordon <assafgordon@gmail.com> | 2016-04-24 18:19:50 -0400 |
commit | c92585b10b29ce2c31c69cea52e69ef053c9679f (patch) | |
tree | ff733fa4b684abfa59dd5a7b3d56f411c9027fee /tests/misc | |
parent | 8c8163838aa5589f5dfe2c94dcc48f0ab443fd35 (diff) | |
download | coreutils-c92585b10b29ce2c31c69cea52e69ef053c9679f.tar.xz |
seq: detect and report I/O errors immediately
Ensure I/O errors are detected (and terminate seq), preventing seq
from infloop (or running for long time with a large
range) upon write errors or ignored SIGPIPE. Examples:
seq 1 inf > /dev/full (seq_fast)
seq 1.1 0.1 inf >/dev/full (print_numbers)
* src/seq.c (io_error): A new function to diagnose appropriate
stdio errors and exit the program with failure status.
(seq_fast, print_numbers): Explicitly check for write errors
and terminate the program with diagnostic.
* tests/misc/seq-io-errors.sh: Test error detection with /dev/full.
* tests/misc/seq-epipe.sh: Test error detection with broken pipes.
* tests/local.mk: Add new tests.
* NEWS: Mention the fix.
Diffstat (limited to 'tests/misc')
-rwxr-xr-x | tests/misc/seq-epipe.sh | 46 | ||||
-rwxr-xr-x | tests/misc/seq-io-errors.sh | 46 |
2 files changed, 92 insertions, 0 deletions
diff --git a/tests/misc/seq-epipe.sh b/tests/misc/seq-epipe.sh new file mode 100755 index 000000000..21e932293 --- /dev/null +++ b/tests/misc/seq-epipe.sh @@ -0,0 +1,46 @@ +#!/bin/sh +# Test for proper detection of EPIPE with ignored SIGPIPE + +# Copyright (C) 2016 Free Software Foundation, Inc. + +# This program is free software: you can redistribute it and/or modify +# it under the terms of the GNU General Public License as published by +# the Free Software Foundation, either version 3 of the License, or +# (at your option) any later version. + +# This program is distributed in the hope that it will be useful, +# but WITHOUT ANY WARRANTY; without even the implied warranty of +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the +# GNU General Public License for more details. + +# You should have received a copy of the GNU General Public License +# along with this program. If not, see <http://www.gnu.org/licenses/>. + +. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src +print_ver_ seq + +# upon EPIPE with signals ignored, 'seq' should exit with an error. +(trap '' PIPE; + timeout 10 sh -c '( (seq inf 2>err ; echo $?>code) | head -n1)'>/dev/null) + +# Exit-code must be 1, indicating 'write error' +cat << \EOF > exp || framework_failure_ +1 +EOF +if test -e code ; then + compare exp code || fail=1 +else + # 'exitcode' file was not created + warn_ "missing exit code file (seq failed to detect EPIPE?)" + fail=1 +fi + +# The error message must begin with "standard output:" +# (but don't hard-code the strerror text) +compare_dev_null_ /dev/null err +if ! grep -qE '^seq: standard output: .+$' err ; then + warn_ "seq emitted incorrect error on EPIPE" + fail=1 +fi + +Exit $fail diff --git a/tests/misc/seq-io-errors.sh b/tests/misc/seq-io-errors.sh new file mode 100755 index 000000000..800718793 --- /dev/null +++ b/tests/misc/seq-io-errors.sh @@ -0,0 +1,46 @@ +#!/bin/sh +# Test for proper detection of I/O errors in seq + +# Copyright (C) 2016 Free Software Foundation, Inc. + +# This program is free software: you can redistribute it and/or modify +# it under the terms of the GNU General Public License as published by +# the Free Software Foundation, either version 3 of the License, or +# (at your option) any later version. + +# This program is distributed in the hope that it will be useful, +# but WITHOUT ANY WARRANTY; without even the implied warranty of +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the +# GNU General Public License for more details. + +# You should have received a copy of the GNU General Public License +# along with this program. If not, see <http://www.gnu.org/licenses/>. + +. "${srcdir=.}/tests/init.sh"; path_prepend_ ./src +print_ver_ seq + +if ! test -w /dev/full || ! test -c /dev/full; then + skip_ '/dev/full is required' +fi + +# Run 'seq' with a timeout, preventing infinite-loop run. +# expected returned codes: +# 1 - seq detected an I/O error and exited with an error. +# 124 - timed-out (seq likely infloop) +# other - unexpected error +timed_seq_fail() { timeout 10 seq "$@" >/dev/full 2>/dev/null; } + + +# Test infinite sequence, using fast-path method (seq_fast). +returns_ 1 timed_seq_fail 1 inf || fail=1 + +# Test infinite sequence, using slow-path method (print_numbers). +returns_ 1 timed_seq_fail 1.1 .1 inf || fail=1 + +# Test non-infinite sequence, using slow-path method (print_numbers). +# (despite being non-infinite, the entire sequence should take long time to +# print. Thus, either an I/O error is detected immediately, or seq will +# timeout). +returns_ 1 timed_seq_fail 1 0.0001 99999999 || fail=1 + +Exit $fail |